<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InternalSupplier2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InternalSupplier2 extends AbstractStructArrayBase
{
    /**
     * The InternalVisaSupplier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InternalSupplier[]
     */
    public $InternalVisaSupplier;
    /**
     * Constructor method for ArrayOfJP_InternalSupplier2
     * @uses ArrayOfJP_InternalSupplier2::setInternalVisaSupplier()
     * @param \StructType\JP_InternalSupplier[] $internalVisaSupplier
     */
    public function __construct(array $internalVisaSupplier = array())
    {
        $this
            ->setInternalVisaSupplier($internalVisaSupplier);
    }
    /**
     * Get InternalVisaSupplier value
     * @return \StructType\JP_InternalSupplier[]|null
     */
    public function getInternalVisaSupplier()
    {
        return $this->InternalVisaSupplier;
    }
    /**
     * Set InternalVisaSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier[] $internalVisaSupplier
     * @return \ArrayType\ArrayOfJP_InternalSupplier2
     */
    public function setInternalVisaSupplier(array $internalVisaSupplier = array())
    {
        foreach ($internalVisaSupplier as $arrayOfJP_InternalSupplier2InternalVisaSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InternalSupplier2InternalVisaSupplierItem instanceof \StructType\JP_InternalSupplier) {
                throw new \InvalidArgumentException(sprintf('The InternalVisaSupplier property can only contain items of \StructType\JP_InternalSupplier, "%s" given', is_object($arrayOfJP_InternalSupplier2InternalVisaSupplierItem) ? get_class($arrayOfJP_InternalSupplier2InternalVisaSupplierItem) : gettype($arrayOfJP_InternalSupplier2InternalVisaSupplierItem)), __LINE__);
            }
        }
        $this->InternalVisaSupplier = $internalVisaSupplier;
        return $this;
    }
    /**
     * Add item to InternalVisaSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier $item
     * @return \ArrayType\ArrayOfJP_InternalSupplier2
     */
    public function addToInternalVisaSupplier(\StructType\JP_InternalSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InternalSupplier) {
            throw new \InvalidArgumentException(sprintf('The InternalVisaSupplier property can only contain items of \StructType\JP_InternalSupplier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->InternalVisaSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InternalSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InternalSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InternalVisaSupplier
     */
    public function getAttributeName()
    {
        return 'InternalVisaSupplier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_InternalSupplier2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
